$! Configure procedure 
$! (c) Alexey Chupahin  9-SEP-2006
$! alex@rostov.ultrastar.ru, elvis_75@mail.ru
$! Clamav 
$!
$!
$ SET NOON
$WRITE SYS$OUTPUT " "
$WRITE SYS$OUTPUT "Configuring CLAMAV for OpenVMS antivirus software"
$WRITE SYS$OUTPUT "(c) Alexey Chupahin   CHAPG"
$WRITE SYS$OUTPUT " "
$! Checking architecture
$DECC = F$SEARCH("SYS$SYSTEM:DECC$COMPILER.EXE") .NES. ""
$    IF F$GETSYI("ARCH_TYPE").EQ.1 THEN CPU = "VAX"
$    IF F$GETSYI("ARCH_TYPE").EQ.2 THEN CPU = "Alpha"
$    IF F$GETSYI("ARCH_TYPE").EQ.3 THEN CPU = "I64"
$WRITE SYS$OUTPUT "Checking architecture 	...  ", CPU
$SHARED=0
$IF ( (CPU.EQS."Alpha").OR.(CPU.EQS."I64") )
$  THEN 
$	SHARED=64
$  ELSE
$	SHARED=32
$ENDIF
$IF (DECC) THEN $WRITE SYS$OUTPUT  "Compiler		...  DEC C"
$IF (.NOT. DECC) THEN $WRITE SYS$OUTPUT  "BAD compiler" GOTO EXIT
$MMS = F$SEARCH("SYS$SYSTEM:MMS.EXE") .NES. ""
$MMK = F$TYPE(MMK) 
$IF (MMS .OR. MMK) THEN GOTO TEST_LIBRARIES
$! I cant find any make tool
$ WRITE SYS$OUTPUT "Install MMS or MMK"
$GOTO EXIT
$!
$!
$!
$TEST_LIBRARIES:
$!   Setting as MAKE utility one of MMS or MMK. I prefer MMS.
$IF (MMK) THEN MAKE="MMK/IGN=WAR"
$IF (MMS) THEN MAKE="MMS/IGN=WAR"
$WRITE SYS$OUTPUT "Checking build utility	...  ''MAKE'"
$WRITE SYS$OUTPUT " "
$!
$!
$IF (P1.EQS."experimental") .OR. (P1.EQS."EXPERIMENTAL") 
$ THEN 
$	HAVE_EXPER=1
$	WRITE SYS$OUTPUT "Experimental code is ENABLED"
$ ELSE
$	HAVE_EXPER=0
$	WRITE SYS$OUTPUT "Experimental code is DISABLED"
$ENDIF
$!"Checking for inet_ntop    "
$ DEFINE SYS$ERROR _NLA0:
$ DEFINE SYS$OUTPUT _NLA0:
$ CC/name=(as_is,short)/float=ieee/ieee=denorm/OBJECT=TEST.OBJ SYS$INPUT
#include <sys/types.h>
#include  <in.h>
#include  <inet.h>

   int main()
     {
	char *s=inet_ntop((int)1, (const void *)NULL,
                             (char *)NULL, (size_t) 1);
     }
$!
$TMP = $STATUS
$DEASS SYS$ERROR
$DEAS  SYS$OUTPUT
$!WRITE SYS$OUTPUT TMP
$IF (TMP .NE. %X10B90001)
$  THEN
$       HAVE_INET_NTOP=0
$       GOTO NEXT00
$ENDIF
$DEFINE SYS$ERROR _NLA0:
$DEFINE SYS$OUTPUT _NLA0:
$LINK/EXE=TEST TEST
$TMP = $STATUS
$DEAS  SYS$ERROR
$DEAS  SYS$OUTPUT
$!WRITE SYS$OUTPUT TMP
$IF (TMP .NE. %X10000001)
$  THEN
$       HAVE_INET_NTOP=0
$       GOTO NEXT0
$  ELSE
$       HAVE_INET_NTOP=1
$ENDIF
$NEXT00:
$IF (HAVE_INET_NTOP.EQ.1)
$  THEN
$       WRITE SYS$OUTPUT "Checking for inet_ntop ...   Yes"
$  ELSE
$       WRITE SYS$OUTPUT "Checking for inet_ntop ...   No"
$ENDIF
$!
$!
$!"Checking for vsnprintf    "
$ DEFINE SYS$ERROR _NLA0:
$ DEFINE SYS$OUTPUT _NLA0:
$ CC/name=(as_is,short)/float=ieee/ieee=denorm/OBJECT=TEST.OBJ SYS$INPUT
   #include <stdio.h>
   #include <stdlib.h>
   #include <varargs.h>
   int main()
     {
        char *s=malloc(12);
        int  i = vsnprintf(s,(size_t)11,"",(va_list) NULL);
     }
$!
$TMP = $STATUS
$DEASS SYS$ERROR
$DEAS  SYS$OUTPUT
$!WRITE SYS$OUTPUT TMP
$IF (TMP .NE. %X10B90001)
$  THEN
$       HAVE_VSNPRINTF=0
$       GOTO NEXT0
$ENDIF
$DEFINE SYS$ERROR _NLA0:
$DEFINE SYS$OUTPUT _NLA0:
$LINK/EXE=TEST TEST
$TMP = $STATUS
$DEAS  SYS$ERROR
$DEAS  SYS$OUTPUT
$!WRITE SYS$OUTPUT TMP
$IF (TMP .NE. %X10000001)
$  THEN
$       HAVE_VSNPRINTF=0
$       GOTO NEXT0
$  ELSE
$       HAVE_VSNPRINTF=1
$ENDIF
$NEXT0:
$IF (HAVE_VSNPRINTF.EQ.1)
$  THEN
$       WRITE SYS$OUTPUT "Checking for vsnprintf ...   Yes"
$  ELSE
$       WRITE SYS$OUTPUT "Checking for vsnprintf ...   No"
$ENDIF
$!
$!
$!"Checking for correct zlib library    "
$ DEFINE SYS$ERROR _NLA0:
$ DEFINE SYS$OUTPUT _NLA0:
$ CC/name=(as_is,short)/float=ieee/ieee=denorm/OBJECT=TEST.OBJ/INCLUDE=(ZLIB) SYS$INPUT
      #include <stdlib.h>
      #include <stdio.h>
      #include <zlib.h>
   int main()
     {
        printf("checking version zlib:  %s\n",zlibVersion());
     }
$TMP = $STATUS
$DEASS SYS$ERROR
$DEAS  SYS$OUTPUT
$!WRITE SYS$OUTPUT TMP
$IF (TMP .NE. %X10B90001)
$  THEN
$       HAVE_ZLIB=0
$	HAVE_SHARED_ZLIB=0
$!       GOTO EXIT
$ENDIF
$DEFINE SYS$ERROR _NLA0:
$DEFINE SYS$OUTPUT _NLA0:
$!Testing for shared ZLIB
$COPY SYS$INPUT []ZLIB.OPT
SYS$SHARE:LIBZSHR/SHARE
$!
$LINK/EXE=TEST TEST,[]ZLIB/OPT
$TMP = $STATUS
$DEL ZLIB.OPT;*
$DEAS SYS$ERROR
$DEAS SYS$OUTPUT
$IF (TMP .NE. %X10000001)
$  THEN
$       HAVE_SHARED_ZLIB=0
$       GOTO NEXT1
$  ELSE
$       HAVE_ZLIB=0
$       HAVE_SHARED_ZLIB=1
$ENDIF
$IF (HAVE_SHARED_ZLIB.EQ.1)
$  THEN
$       WRITE SYS$OUTPUT "Checking for correct shared zlib library ...   Yes"
$	RUN TEST
$	GOTO NEXT2
$  ELSE
$ENDIF
$!
$NEXT1:
$DEFINE SYS$ERROR _NLA0:
$DEFINE SYS$OUTPUT _NLA0:
$LINK/EXE=TEST TEST,sys$library:LIBZ/LIB
$TMP = $STATUS
$DEAS  SYS$ERROR
$DEAS  SYS$OUTPUT
$!WRITE SYS$OUTPUT TMP
$IF (TMP .NE. %X10000001)
$  THEN
$       HAVE_ZLIB=0
$  ELSE
$       HAVE_ZLIB=1
$ENDIF
$IF (HAVE_ZLIB.EQ.1)
$  THEN
$       WRITE SYS$OUTPUT "Checking for correct zlib library ...   Yes"
$	RUN TEST
$  ELSE
$       WRITE SYS$OUTPUT "Checking for correct zlib library ...   No"
$       WRITE SYS$OUTPUT "This is fatal. Please download and install good library from fafner.dyndns.org/~alexey/libsdl/public.html"
$	WRITE SYS$OUTPUT "copy LIBZSHR.EXE to SYS$SHARE if any or stay with static LIBZ.OLB"
$	WRITE SYS$OUTPUT "Do not forget define ZLIB logical to your path where LIBZ.OLB and include files are located"
$	WRITE SYS$OUTPUT ""
$	GOTO EXIT
$ENDIF
$!
$NEXT2:
$!
$! Checking for BZIP2 library
$!
$ DEFINE SYS$ERROR _NLA0:
$ DEFINE SYS$OUTPUT _NLA0:
$ CC/name=(as_is,short)/float=ieee/ieee=denorm/OBJECT=TEST.OBJ/INCLUDE=(BZ2LIB) SYS$INPUT
      #include <stdlib.h>
      #include <stdio.h>
      #include <bzlib.h>
   int main()
     {
        printf("checking version bzip2 library:  %s\n",BZ2_bzlibVersion());
     }
$TMP = $STATUS
$DEASS SYS$ERROR
$DEAS  SYS$OUTPUT
$!WRITE SYS$OUTPUT TMP
$IF (TMP .NE. %X10B90001)
$  THEN
$       HAVE_BZIP2=0
$	HAVE_CHAPG_BZIP2=0
$       WRITE SYS$OUTPUT "Checking for correct bzip2 library ...   No"
$       WRITE SYS$OUTPUT "To get bzip2 archives support, please download and install good library ported by Alexey Chhupahin from openvms clamav site or HP OpenVMS freeware." 
$       WRITE SYS$OUTPUT "Then define logical BZ2LIB to the path where your library file BZIP2.OLB and BZLIB.H are located"
$	WRITE SYS$OUTPUT ""
$       GOTO NEXT4
$ENDIF
$DEFINE SYS$ERROR _NLA0:
$DEFINE SYS$OUTPUT _NLA0:
$!Testing for CHAPG BZIP2
$!
$LINK/EXE=TEST TEST,BZ2LIB:BZIP2/OPT
$TMP = $STATUS
$DEAS SYS$ERROR
$DEAS SYS$OUTPUT
$IF (TMP .NE. %X10000001)
$  THEN
$       HAVE_CHAPG_BZIP2=0
$       GOTO NEXT3
$  ELSE
$       HAVE_BZIP2=0
$       HAVE_CHAPG_BZIP2=1
$ENDIF
$IF (HAVE_CHAPG_BZIP2.EQ.1)
$  THEN
$       WRITE SYS$OUTPUT "Checking for CHAPG bzip2  library ...   Yes"
$	RUN TEST
$       GOTO NEXT4
$  ELSE
$ENDIF
$!
$NEXT3:
$DEFINE SYS$ERROR _NLA0:
$DEFINE SYS$OUTPUT _NLA0:
$LINK/EXE=TEST TEST,sys$library:libBZ2/LIB
$TMP = $STATUS
$DEAS  SYS$ERROR
$DEAS  SYS$OUTPUT
$!WRITE SYS$OUTPUT TMP
$IF (TMP .NE. %X10000001)
$  THEN
$       HAVE_BZIP2=0
$  ELSE
$       HAVE_BZIP2=1
$ENDIF
$IF (HAVE_BZIP2.EQ.1)
$  THEN
$       WRITE SYS$OUTPUT "Checking for correct bzip2 library ...   Yes"
$	RUN TEST
$  ELSE
$       WRITE SYS$OUTPUT "Checking for correct bzip2 library ...   No"
$       WRITE SYS$OUTPUT "To get bzip2 archives support, please download and install library ported by Alexey Chupahin from OpenVMS Clamav site or HP OpenVMS freeware." 
$       WRITE SYS$OUTPUT "Then define logical BZ2LIB to the path where your library file BZIP2.OLB and BZLIB.H are located"
$	WRITE SYS$OUTPUT " "
$ENDIF
$!
$NEXT4:
$!
$!Check for fcntl(...,F_GETFL) functions. 
$!Compaq C prior 7.1 have no this feature
$!
$ DEFINE SYS$ERROR _NLA0:
$ DEFINE SYS$OUTPUT _NLA0:
$ CC/name=(as_is,short)/float=ieee/ieee=denorm/OBJECT=TEST.OBJ/INCLUDE=(ZLIB) SYS$INPUT
      #include <stdlib.h>
      #include <unistd.h>
      #include <netinet/in.h>
      #include <netdb.h>
      #include <fcntl.h>
   int main()
     {
	int sock,fcntl_flags;
	sock = socket(AF_INET, SOCK_STREAM, 0);
	fcntl_flags = fcntl(sock, F_GETFL, 0);
	close(sock);
	if (fcntl_flags== -1) { exit(2); perror("!!!!\n"); }
	return 0;
     }
$TMP = $STATUS
$DEASS SYS$ERROR
$DEAS  SYS$OUTPUT
$!WRITE SYS$OUTPUT TMP
$IF (TMP .NE. %X10B90001)
$  THEN
$       HAVE_F_GETFL=0
$       GOTO NEXT5
$ENDIF
$!
$ DEFINE SYS$ERROR _NLA0:
$ DEFINE SYS$OUTPUT _NLA0:
$LINK/EXE=TEST TEST
$TMP = $STATUS
$DEAS  SYS$ERROR
$DEAS  SYS$OUTPUT
$!WRITE SYS$OUTPUT TMP
$IF (TMP .NE. %X10000001)
$  THEN
$       HAVE_F_GETFL=0
$       GOTO NEXT5
$ENDIF
$ DEFINE SYS$ERROR _NLA0:
$ DEFINE SYS$OUTPUT _NLA0:
$RUN TEST
$TMP = $STATUS
$DEAS  SYS$ERROR
$DEAS  SYS$OUTPUT
$IF(TMP .NE. %X00000001)
$  THEN
$       HAVE_F_GETFL=0
$       GOTO NEXT5
$  ELSE
$       HAVE_F_GETFL=1
$ENDIF
$NEXT5:
$IF (HAVE_F_GETFL.EQ.1)
$  THEN
$       WRITE SYS$OUTPUT "Checking for F_GETFL feature in fcntl() ...   Yes"
$  ELSE
$       WRITE SYS$OUTPUT "Checking for F_GETFL feature in fcntl() ...   No"
$       WRITE SYS$OUTPUT "It leads to disable timeout connection feature in FRESHCLAM updater."
$	WRITE SYS$OUTPUT ""
$ENDIF
$!
$!
$!WRITING BUILD FILES
$OPEN/WRITE OUT BUILD.COM
$ WRITE OUT "$if f$search(""BIN.DIR"") .eqs. """" then crea/d [.BIN]"
$ WRITE OUT "$if f$search(""TMP.DIR"") .eqs. """" then crea/d [.TMP]"
$ WRITE OUT "$set def [.SHARED]"
$ WRITE OUT "$",MAKE
$ WRITE OUT "$set def [-.LIBCLAMAV]"
$ WRITE OUT "$",MAKE
$ WRITE OUT "$set def [-.CLAMSCAN]"
$ WRITE OUT "$",MAKE
$ WRITE OUT "$set def [-.CLAMD]"
$ WRITE OUT "$",MAKE
$ WRITE OUT "$set def [-.CLAMDSCAN]"
$ WRITE OUT "$",MAKE
$ WRITE OUT "$set def [-.FRESHCLAM]"
$ WRITE OUT "$",MAKE
$ WRITE OUT "$set def [-.CLAMCONF]"
$ WRITE OUT "$",MAKE
$ WRITE OUT "$set def [-]"
$ WRITE OUT "$ CURRENT = F$ENVIRONMENT (""DEFAULT"") "
$ WRITE OUT "$CLAM=CURRENT"
$ WRITE OUT "$OPEN/WRITE OUTT CLAMAV$STARTUP.COM"
$ WRITE OUT "$CLAM[F$LOCATE(""]"",CLAM),10]:="".DATABASE]"""
$ WRITE OUT "$WRITE OUTT ""DEFINE CLAMAV_DATA ","'","'","CLAM'""
$ WRITE OUT "$CLAM=CURRENT"
$ WRITE OUT "$CLAM[F$LOCATE(""]"",CLAM),9]:="".TMP]"""
$ WRITE OUT "$WRITE OUTT ""DEFINE CLAMAV_TMP ","'","'","CLAM'""
$ WRITE OUT "$CLAM=CURRENT"
$ WRITE OUT "$CLAM[F$LOCATE(""]"",CLAM),9]:="".ETC]"""
$ WRITE OUT "$WRITE OUTT ""DEFINE CLAMAV_ETC ","'","'","CLAM'""
$ WRITE OUT "$CLAM=CURRENT"
$ WRITE OUT "$CLAM[F$LOCATE(""]"",CLAM),5]:="".BIN]"""
$ WRITE OUT "$WRITE OUTT ""CLAMSCAN:==$", "'","'","CLAM'CLAMSCAN"""
$ WRITE OUT "$WRITE OUTT ""CLAMD:==$", "'","'","CLAM'CLAMD"""
$ WRITE OUT "$WRITE OUTT ""FRESHCLAM:==$", "'","'","CLAM'FRESHCLAM"""
$ WRITE OUT "$CLOSE OUTT"
$ WRITE OUT "$OPEN/WRITE OUTT [.BIN]START$CLAMD.COM"
$ WRITE OUT "$WRITE OUTT ""SPAWN/NOWAIT/OUT=CLAMAV_DATA:CLAMD.LOG/PROC=CLAMD CLAMD""
$ WRITE OUT "$CLOSE OUTT"
$ WRITE OUT "$OPEN/WRITE OUTT [.BIN]STOP$CLAMD.COM"
$ WRITE OUT "$WRITE OUTT ""STOP CLAMD""
$ WRITE OUT "$CLOSE OUTT"
$ WRITE OUT "$OPEN/WRITE OUTT [.BIN]START$FRESHCLAM.COM"
$ WRITE OUT "$WRITE OUTT ""SPAWN/NOWAIT/OUT=CLAMAV_DATA:FRESHCLAM.LOG/PROC=FRESHCLAM FRESHCLAM -d -c 1 --daemon-notify""
$ WRITE OUT "$CLOSE OUTT"
$ WRITE OUT "$OPEN/WRITE OUTT [.BIN]STOP$FRESHCLAM.COM"
$ WRITE OUT "$WRITE OUTT ""STOP FRESHCLAM""
$ WRITE OUT "$CLOSE OUTT"
$!
$ WRITE OUT "$WRITE SYS$OUTPUT "" ""
$ WRITE OUT "$WRITE SYS$OUTPUT ""***************************************************************************** ""
$ WRITE OUT "$WRITE SYS$OUTPUT ""Compilation is completed. All executables has been created and placed to [.BIN]. ""
$ WRITE OUT "$WRITE SYS$OUTPUT ""CLAMAV$STARTUP.COM is created. ""
$ WRITE OUT "$WRITE SYS$OUTPUT ""This file setups all logicals needed. It should be executed before starting Clamav. ""
$ WRITE OUT "$WRITE SYS$OUTPUT ""***************************************************************************** ""
$CLOSE OUT
$! BUILD.COM finished
$ WRITE SYS$OUTPUT "BUILD.COM has been created"
$!
$!Creating OPT.OPT file containig external libraries (zlib,bzip2) for linker
$OPEN/WRITE OUT []OPT.OPT
$IF (HAVE_SHARED_ZLIB.EQ.1)  THEN  WRITE OUT "SYS$SHARE:LIBZSHR/SHARE"
$IF (HAVE_ZLIB.EQ.1)	     THEN  WRITE OUT "sys$library:LIBZ/LIB"
$IF (HAVE_BZIP2.EQ.1)	     THEN  WRITE OUT "sys$library:libBZ2/LIB"
$!WRITE OUT "SYS$SHARE:VMS_JACKETS/SHARE
$CLOSE OUT
$IF (HAVE_CHAPG_BZIP2.EQ.1) THEN APP BZ2LIB:BZIP2.OPT OPT.OPT
$!
$WRITE SYS$OUTPUT "OPT.OPT has been created"
$!
$!Creating CLAMAV-CONFIG.H
$COPY SYS$INPUT []CLAMAV-CONFIG.H
#define PACKAGE_NAME ""
#define PACKAGE_TARNAME ""
#define PACKAGE_VERSION ""
#define PACKAGE_STRING ""
#define PACKAGE_BUGREPORT ""
#define PACKAGE "clamav"
#define VERSION "0.90.2 VMS"
#define STDC_HEADERS 1
//#define HAVE_MKSTEMP
#define HAVE_SYS_TYPES_H 1
#define HAVE_SYS_STAT_H 1
#define HAVE_STDLIB_H 1
#define HAVE_STRING_H 1
#define HAVE_MEMORY_H 1
#define HAVE_STRINGS_H 1
#define HAVE_INTTYPES_H 1
#define HAVE_UNISTD_H 1
#define HAVE_DLFCN_H 1
#define SCANBUFF 131072
#define FILEBUFF 8192
#define STDC_HEADERS 1
#define HAVE_UNISTD_H 1
#define HAVE_DLFCN_H 1
#define HAVE_INTTYPES_H 1
#define HAVE_SYS_INTTYPES_H 1
#define HAVE_MEMORY_H 1
#define HAVE_STDLIB_H 1
#define HAVE_STRINGS_H 1
#define HAVE_STRING_H 1
#define HAVE_SYS_MMAN_H 1
#define HAVE_SYS_STAT_H 1
#define HAVE_SYS_TYPES_H 1
#define HAVE_LIMITS_H 1
#define HAVE_SYS_UIO_H 1
#define HAVE_REGEX_H 1
#define SIZEOF_SHORT 2
#define SIZEOF_INT 4
#define SIZEOF_LONG 4
#define SIZEOF_LONG_LONG 8
#define HAVE_SETSID 1
#define HAVE_MEMCPY 1
#define HAVE_INET_NTOP 1
#define HAVE_CTIME_R 1
#define HAVE_STDLIB_H 1
#define HAVE_UNISTD_H 1
#define HAVE_GETPAGESIZE 1
#define HAVE_FSEEKO 1
//#define HAVE_RESOLV_H 1
#define CLAMAVUSER "clamav"
#define CLAMAVGROUP "clamav"
#define DB1NAME "main.cvd"
#define DB2NAME "daily.cvd"
#define DATADIR "/CLAMAV_DATA"
#define TMPDIR "/CLAMAV_TMP"
#define CONFDIR "/CLAMAV_ETC"
#define HAVE_IN_PORT_T 1
#define HAVE_IN_ADDR_T 1
#define BUILD_CLAMD 1
#define HAVE_RECVMSG 1
#define HAVE_SENDMSG 1
#define HAVE_ACCRIGHTS_IN_MSGHDR 1
#define HAVE_CTIME_R_2 1
#define WORDS_BIGENDIAN 0
#define HAVE_PRAGMA_PACK 1
#define NO_FD_SET 1
#define DEFAULT_FD_SETSIZE 256
#define logg printf
#define CL_DEBUG 1
#define C_BIGSTACK 1
#define HAVE_READDIR_R_3 1
//#define NO_SNPRINTF
#define HAVE_GETOPT 1
#define HAVE_MMAP 1
typedef unsigned int socklen_t;
#define MAXHOSTNAMELEN 255
#define MAXPATHLEN     255
#define fork vfork
#define open VMS_OPEN

/* To avoid warning messages at linking stage */
#define getopt VMS_GETOPT
#define optopt VMS_OPTOPT
#define opterr VMS_OPTERR
#define optind VMS_OPTIND

#ifndef O_BINARY
#define O_BINARY 020
#endif
#ifndef O_BINARY
#define O_BINARY        0
#endif

#define HAVE_PWD_H 1
#define HAVE_GRP_H 1
#define DONT_LOCK_DBDIRS 1

$ IF ( HAVE_EXPER.EQ.1 )
$    THEN
$	APP SYS$INPUT []CLAMAV-CONFIG.H
#define  CL_EXPERIMENTAL 1
$ ENDIF
$!
$ IF ( HAVE_INET_NTOP.EQ.1)
$    THEN
$	APP SYS$INPUT []CLAMAV-CONFIG.H
	#define HAVE_INET_NTOP 1
$ ENDIF
$ IF ( HAVE_VSNPRINTF.EQ.1)
$    THEN
$	APP SYS$INPUT []CLAMAV-CONFIG.H
	#define HAVE_SNPRINTF 1
	#define HAVE_VSNPRINTF 1
$    ELSE
$	APP SYS$INPUT []CLAMAV-CONFIG.H
	#define BROKEN_SNPRINTF
	#undef HAVE_VSNPRINTF
$ ENDIF
$ IF ( HAVE_F_GETFL.EQ.1 )
$  THEN
$	APP SYS$INPUT []CLAMAV-CONFIG.H
#define HAVE_F_GETFL 1
$ ENDIF
$ IF ( HAVE_ZLIB.EQ.1  .OR.  HAVE_SHARED_ZLIB.EQ.1 )
$  THEN
$	APP SYS$INPUT []CLAMAV-CONFIG.H
#define HAVE_ZLIB_H 1
$ ENDIF
$!
$ IF ( HAVE_BZIP2.EQ.1  .OR.  HAVE_CHAPG_BZIP2.EQ.1 )
$  THEN
$	APP SYS$INPUT []CLAMAV-CONFIG.H
#define HAVE_BZLIB_H 1
$ ENDIF
$!
$WRITE SYS$OUTPUT "CLAMAV-CONFIG.H has been created"
$!
$!
$! Create [.INCLUDE] with specific include files
$!
$IF F$SEARCH("INCLUDE.DIR") .EQS. ""  THEN CREA/D [.INCLUDE]
$ COPY SYS$INPUT [.INCLUDE]GLOB.H
typedef struct
{
     size_t gl_pathc;    /* Count of paths matched so far  */
     char **gl_pathv;    /* List of matched pathnames.  */
     size_t gl_offs;     /* Slots to reserve in 'gl_pathv'.  */
} glob_t;

#define MAXLEN 500
#define GLOB_DOOFFS 0

#include <ssdef.h>
#include <rms.h>
#include <descrip.h>
#include <string.h>
#include <unixlib.h>
#include <starlet.h>
#include <fabdef.h>
#include <rabdef.h>
#include <rmsdef.h>
#include <stsdef.h>

#define default_name "*.*;*"

int glob(const char *pattern, int flags,
         int errfunc(const char *epath, int eerrno),
         glob_t *pglob);

void globfree(glob_t *pglob);

$ IF CPU .EQS. "Alpha"
$  THEN
$    COPY SYS$INPUT [.INCLUDE]TARGET.H
#ifndef TARGET_OS_VMS
#define TARGET_OS_VMS "vms"
#endif

#ifndef TARGET_OS_TYPE
#define TARGET_OS_TYPE "vms"
#endif

#ifndef TARGET_CPU_ALPHA
#define TARGET_CPU_ALPHA "alpha"
#endif

#ifndef TARGET_CPU_TYPE
#define TARGET_CPU_TYPE "alpha"
#endif

#ifndef TARGET_ARCH_ALPHA
#define TARGET_ARCH_ALPHA "alpha"
#endif

#ifndef TARGET_ARCH_TYPE
#define TARGET_ARCH_TYPE "alpha"
#endif
/* host uppercase defines */

#ifndef HOST_OS_VMS
#define HOST_OS_VMS "vms"
#endif

#ifndef HOST_OS_TYPE
#define HOST_OS_TYPE "vms"
#endif

#ifndef HOST_CPU_ALPHA
#define HOST_CPU_ALPHA "alpha"
#endif

#ifndef HOST_CPU_TYPE
#define HOST_CPU_TYPE "alpha"
#endif

#ifndef HOST_ARCH_ALPHA
#define HOST_ARCH_ALPHA "alpha"
#endif

#ifndef HOST_ARCH_TYPE
#define HOST_ARCH_TYPE "alpha"
#endif
$ ENDIF
$ IF CPU .EQS. "I64"
$  THEN
$ #ifndef TARGET_OS_VMS
#define TARGET_OS_VMS "vms"
#endif

#ifndef TARGET_OS_TYPE
#define TARGET_OS_TYPE "vms"
#endif

#ifndef TARGET_CPU_I64
#define TARGET_CPU_I64 "i64"
#endif

#ifndef TARGET_CPU_TYPE
#define TARGET_CPU_TYPE "i64"
#endif

#ifndef TARGET_ARCH_I64
#define TARGET_ARCH_I64 "i64"
#endif

#ifndef TARGET_ARCH_TYPE
#define TARGET_ARCH_TYPE "i64"
#endif
/* host uppercase defines */

#ifndef HOST_OS_VMS
#define HOST_OS_VMS "vms"
#endif

#ifndef HOST_OS_TYPE
#define HOST_OS_TYPE "vms"
#endif

#ifndef HOST_CPU_I64
#define HOST_CPU_I64 "i64"
#endif

#ifndef HOST_CPU_TYPE
#define HOST_CPU_TYPE "i64"
#endif

#ifndef HOST_ARCH_I64
#define HOST_ARCH_I64 "i64"
#endif

#ifndef HOST_ARCH_TYPE
#define HOST_ARCH_TYPE "i64"
#endif
$ ENDIF
$!
$WRITE SYS$OUTPUT "[.INCLUDE]TARGET.H has been created"
$!
$!
$!
$!Creating Descrip.mms in each directory needed
$!
$! DESCRIP.MMS in [.SHARED]
$!
$COPY SYS$INPUT [.SHARED]DESCRIP.MMS
# (c) Alexey Chupahin 17-DEC-2006        OpenVMS 7.3-1, DEC 2000 mod.300

.FIRST
        DEF LIBCLAMAV [-.LIBCLAMAV]
        DEF SHARED []

CC=cc

CFLAGS =  /INCLUDE=([],[-],ZLIB,[-.include],[-.CLAMSCAN],[-.LIBCLAMAV]) /DEFINE=(HAVE_CONFIG_H,"CL_SCAN_ALGO"="CL_SCAN_ALGORITHMIC") /FLOAT=IEEE/IEEE=DENORM  \
/OPTIMIZE=(INLINE=SPEED)/name=(as_is,short) \
/OBJ=$> /DEB


OBJ = \
CDIFF.OBJ,\
CFGPARSER.OBJ,\
MISC.OBJ,\
NETWORK.OBJ,\
OPTIONS-VMS.OBJ,\
OUTPUT.OBJ,\
GETOPT.OBJ

LIBSHARED.OLB : $(OBJ)
        lib/cre []LIBSHARED $(OBJ)

CDIFF.OBJ : CDIFF.c
CFGPARSER.OBJ : CFGPARSER.c
MISC.OBJ : MISC.c
NETWORK.OBJ : NETWORK.c
OPTIONS-VMS.OBJ : OPTIONS-VMS.c
OUTPUT.OBJ : OUTPUT.c
GETOPT.OBJ : GETOPT.c
$!
$!Descrip in LIBCLAMAV
$!
$COPY SYS$INPUT [.LIBCLAMAV]DESCRIP.MMS
# (c) Alexey Chupahin 17-DEC-2006        OpenVMS 7.3-1, DEC 2000 mod.300

CC=cc

CFLAGS =  /INCLUDE=([],[-],ZLIB,BZ2LIB,[-.include],[.UNRAR]) /FLOAT=ieee /ieee=denorm/DEFINE=(HAVE_CONFIG_H,RAR_HIGH_DEBUG) \
/OPTIMIZE=(INLINE=SPEED) /WARN=(DIS=(MACROREDEF,UNDEFESCAP,FOUNDCR,NOTCONSTQUAL))\
/name=(as_is,short)/OBJ=$> /DEB


OBJ = \
BINHEX.OBJ,\
BLOB.OBJ,\
CAB.OBJ,\
CHMUNPACK.OBJ,\
CVD.OBJ,\
DCONF.OBJ,\
DSIG.OBJ,\
ELF.OBJ,\
ENTCONV.OBJ,\
FILETYPES.OBJ,\
FSG.OBJ,\
HASHTAB.OBJ,\
HTMLNORM.OBJ,\
IS_TAR.OBJ,\
LINE.OBJ,\
LOCKDB.OBJ,\
MATCHER-AC.OBJ,\
MATCHER-BM.OBJ,\
MATCHER-NCORE.OBJ,\
MATCHER.OBJ,\
MBOX.OBJ,\
MD5.OBJ,\
MESSAGE.OBJ,\
MEW.OBJ,\
MSEXPAND.OBJ,\
MSPACK.OBJ,\
OLE2_EXTRACT.OBJ,\
OTHERS.OBJ,\
PACKLIBS.OBJ,\
PDF.OBJ,\
PE.OBJ,\
PETITE.OBJ,\
PHISHCHECK.OBJ,\
PHISH_DOMAINCHECK_DB.OBJ,\
PHISH_WHITELIST.OBJ,\
READDB.OBJ,\
REBUILDPE.OBJ,\
REGEX.OBJ,\
REGEX_LIST.OBJ,\
RTF.OBJ,\
SCANNERS.OBJ,\
SHA256.OBJ,\
SIS.OBJ,\
SNPRINTF.OBJ,\
SPECIAL.OBJ,\
SPIN.OBJ,\
STR.OBJ,\
SUECRYPT.OBJ,\
TABLE.OBJ,\
TEXT.OBJ,\
TNEF.OBJ,\
UNSP.OBJ,\
UNTAR.OBJ,\
UNZIP.OBJ,\
UPACK.OBJ,\
UPX.OBJ,\
UUENCODE.OBJ,\
VBA_EXTRACT.OBJ,\
VMS2UNIX.OBJ,\
WWUNPACK.OBJ,\
YC.OBJ

UNRAR_OBJ = \
[.UNRAR]UNRAR.OBJ,\
[.UNRAR]UNRAR15.OBJ,\
[.UNRAR]UNRAR20.OBJ,\
[.UNRAR]UNRARCMD.OBJ,\
[.UNRAR]UNRARFILTER.OBJ,\
[.UNRAR]UNRARPPM.OBJ,\
[.UNRAR]UNRARVM.OBJ


ALL : LIBCLAMAV.OLB
	$!

BINHEX.OBJ : BINHEX.C
	OPEN/WRI OUT VMS.VMS
	WRITE OUT "#include <types.h>"
	WRITE OUT "#include <mman.h>"
	CLOSE OUT
	COPY/CONCAT VMS.VMS,BINHEX.C BINHEX.C_
	$(CC) $(CFLAGS) BINHEX.C_
	DEL BINHEX.C_;*
	DEL VMS.VMS;*

LIBCLAMAV.OLB : $(OBJ), $(UNRAR_OBJ)
        lib/cre []LIBCLAMAV $(OBJ)
        lib/ins []LIBCLAMAV $(UNRAR_OBJ)

HTMLNORM.OBJ : HTMLNORM.C
        CC $(CFLAGS) /WARN=DIS=(PTRMISMATCH1,NOTCONSTQUAL) HTMLNORM

OLE2_EXTRACT.OBJ : OLE2_EXTRACT.C
        CC $(CFLAGS) /WARN=DIS=(PTRMISMATCH1,NOTCONSTQUAL) OLE2_EXTRACT

UNTAR.OBJ : UNTAR.C
        CC $(CFLAGS) /WARN=DIS=(PTRMISMATCH1,NOTCONSTQUAL) UNTAR

BINHEX.OBJ : BINHEX.c
BLOB.OBJ : BLOB.c
CAB.OBJ : CAB.c
CHMUNPACK.OBJ : CHMUNPACK.c
CVD.OBJ : CVD.c
DCONF.OBJ : DCONF.c
DSIG.OBJ : DSIG.c
ELF.OBJ : ELF.c
ENTCONV.OBJ : ENTCONV.c
FILETYPES.OBJ : FILETYPES.c
FSG.OBJ : FSG.c
HASHTAB.OBJ : HASHTAB.c
IS_TAR.OBJ : IS_TAR.c
LINE.OBJ : LINE.c
LOCKDB.OBJ : LOCKDB.c
MATCHER-AC.OBJ : MATCHER-AC.c
MATCHER-BM.OBJ : MATCHER-BM.c
MATCHER-NCORE.OBJ : MATCHER-NCORE.c
MATCHER.OBJ : MATCHER.c
MBOX.OBJ : MBOX.c
MD5.OBJ : MD5.c
MESSAGE.OBJ : MESSAGE.c
MEW.OBJ : MEW.c
MSEXPAND.OBJ : MSEXPAND.c
MSPACK.OBJ : MSPACK.c
OTHERS.OBJ : OTHERS.c
PACKLIBS.OBJ : PACKLIBS.c
PDF.OBJ : PDF.c
PE.OBJ : PE.c
PETITE.OBJ : PETITE.c
PHISHCHECK.OBJ : PHISHCHECK.c
PHISH_DOMAINCHECK_DB.OBJ : PHISH_DOMAINCHECK_DB.c
PHISH_WHITELIST.OBJ : PHISH_WHITELIST.c
READDB.OBJ : READDB.c
REBUILDPE.OBJ : REBUILDPE.c
REGEX.OBJ : REGEX.c
REGEX_LIST.OBJ : REGEX_LIST.c
RTF.OBJ : RTF.c
SCANNERS.OBJ : SCANNERS.c
SHA256.OBJ : SHA256.c
SIS.OBJ : SIS.c
SNPRINTF.OBJ : SNPRINTF.c
SPECIAL.OBJ : SPECIAL.c
SPIN.OBJ : SPIN.c
STR.OBJ : STR.c
SUECRYPT.OBJ : SUECRYPT.c
TABLE.OBJ : TABLE.c
TEXT.OBJ : TEXT.c
TNEF.OBJ : TNEF.c
UNSP.OBJ : UNSP.c
UNZIP.OBJ : UNZIP.c
UPACK.OBJ : UPACK.c
UPX.OBJ : UPX.c
UUENCODE.OBJ : UUENCODE.c
VBA_EXTRACT.OBJ : VBA_EXTRACT.c
VMS2UNIX.OBJ : VMS2UNIX.c
WWUNPACK.OBJ : WWUNPACK.c
YC.OBJ : YC.c
[.UNRAR]UNRAR.OBJ : [.UNRAR]UNRAR.c
[.UNRAR]UNRAR15.OBJ : [.UNRAR]UNRAR15.c
[.UNRAR]UNRAR20.OBJ : [.UNRAR]UNRAR20.c
[.UNRAR]UNRARCMD.OBJ : [.UNRAR]UNRARCMD.c
[.UNRAR]UNRARFILTER.OBJ : [.UNRAR]UNRARFILTER.c
[.UNRAR]UNRARPPM.OBJ : [.UNRAR]UNRARPPM.c
[.UNRAR]UNRARVM.OBJ : [.UNRAR]UNRARVM.c
$!
$!
$! Descrip CLAMSCAN
$!
$COPY SYS$INPUT [.CLAMSCAN]DESCRIP.MMS
# (c) Alexey Chupahin 17-DEC-2006        OpenVMS 7.3-1, DEC 2000 mod.300

.FIRST
        $DEF LIBCLAMAV [-.LIBCLAMAV]
        $DEF SHARED [-.SHARED]

CC=cc

CFLAGS =  /INCLUDE=([],[-],ZLIB,[-.include],[-.LIBCLAMAV],[-.SHARED],[-.CONTRIB.WINDOWS.PROJECTS.CLAMAV.LIBCLAMAV]) /DEFINE=(HAVE_CONFIG_H)  \
/OPTIMIZE=(INLINE=SPEED) /FLOAT=ieee/ieee=denorm/name=(as_is,short)\
/OBJ=$>


OBJ = \
CLAMSCAN.OBJ,\
MANAGER.OBJ,\
OTHERS.OBJ,\
TREEWALK.OBJ

ALL : CLAMSCAN.EXE
        ren CLAMSCAN.EXE [-.BIN]

CLAMSCAN.EXE : $(OBJ)
        LINK/EXE=CLAMSCAN $(OBJ),[-.SHARED]LIBSHARED/LIB,[-.LIBCLAMAV]LIBCLAMAV/LIB , [-]OPT/OPT

CLAMSCAN.OBJ : CLAMSCAN.c
MANAGER.OBJ : MANAGER.c
OTHERS.OBJ : OTHERS.c
TREEWALK.OBJ : TREEWALK.c
$!
$! Descrip in CLAMD
$!
$COPY SYS$INPUT [.CLAMD]DESCRIP.MMS
# (c) Alexey Chupahin 17-DEC-2006        OpenVMS 7.3-1, DEC 2000 mod.300
# (c) Alexey Chupahin 17-DEC-2006        OpenVMS 7.3-1, DEC 2000 mod.300

.FIRST
        DEF LIBCLAMAV [-.LIBCLAMAV]
        DEF SHARED [-.SHARED]



CC=cc

CFLAGS =  /INCLUDE=([],[-],ZLIB,[-.include],[-.LIBCLAMAV],[-.SHARED]) /DEFINE=(HAVE_CONFIG_H) /DEB \
/OPTIMIZE=(INLINE=SPEED) /FLOAT=ieee/ieee=denorm/name=(as_is,short)\
/OBJ=$>


OBJ = \
CLAMD.OBJ,\
LOCALSERVER_VMS.OBJ,\
OTHERS.OBJ,\
SCANNER.OBJ,\
SESSION.OBJ,\
SERVER-TH.OBJ,\
TCPSERVER.OBJ,\
THRMGR.OBJ


ALL : CLAMD.EXE
        $ren []clamd.exe [-.BIN]

CLAMD.EXE : $(OBJ)
        LIB/CREA LIBCLAMD $(OBJ)
        LINK/EXE=CLAMD $(OBJ),[-.SHARED]LIBSHARED/LIB,[-.LIBCLAMAV]LIBCLAMAV/LIB , [-]OPT/OPT

CLAMD.OBJ : CLAMD.c
LOCALSERVER_VMS.OBJ : LOCALSERVER_VMS.c
OTHERS.OBJ : OTHERS.c
SCANNER.OBJ : SCANNER.c
SESSION.OBJ : SESSION.c
SERVER-TH.OBJ : SERVER-TH.c
TCPSERVER.OBJ : TCPSERVER.c
THRMGR.OBJ : THRMGR.c
$!
$! DESCRIP on CLAMDSCAN
$!
$COPY SYS$INPUT [.CLAMDSCAN]DESCRIP.MMS
.FIRST
        $DEF LIBCLAMAV [-.LIBCLAMAV]
        $DEF SHARED [-.SHARED]
        $DEF CLAMSCAN [-.CLAMSCAN]

CC=cc

CFLAGS =  /INCLUDE=([],[-],ZLIB,[-.include],[-.CLAMSCAN],[-.LIBCLAMAV],[-.SHARED],[-.CLAMD])\
/DEFINE=(HAVE_CONFIG_H) /DEB /WARN=(DIS=(PTRMISMATCH,PTRMISMATCH1))\
/OPTIMIZE=(INLINE=SPEED) /FLOAT=ieee/ieee=denorm/name=(as_is,short)\
/OBJ=$>


OBJ = \
CLAMDSCAN.OBJ,\
CLIENT.OBJ

ALL : CLAMDSCAN.EXE
        $ren CLAMDSCAN.EXE [-.BIN]

CLAMDSCAN.EXE : $(OBJ)
        LINK/EXE=CLAMDSCAN $(OBJ),[-.SHARED]LIBSHARED/LIB,[-.LIBCLAMAV]LIBCLAMAV/LIB , [-]OPT/OPT

CLAMDSCAN.OBJ : CLAMDSCAN.c
CLIENT.OBJ : CLIENT.c
$!
$! DESCRIP on CLAMCONF
$!
$COPY SYS$INPUT [.CLAMCONF]DESCRIP.MMS
.FIRST
        $DEF LIBCLAMAV [-.LIBCLAMAV]
        $DEF SHARED [-.SHARED]
        $DEF CLAMSCAN [-.CLAMSCAN]

CC=cc

CFLAGS =  /INCLUDE=([],[-],ZLIB,[-.include],[-.CLAMSCAN],[-.LIBCLAMAV],[-.SHARED],[-.CLAMD])\
/DEFINE=(HAVE_CONFIG_H) /DEB /WARN=(DIS=(PTRMISMATCH,PTRMISMATCH1))\
/OPTIMIZE=(INLINE=SPEED) /FLOAT=ieee/ieee=denorm/name=(as_is,short)\
/OBJ=$>


OBJ = \
CLAMCONF.OBJ

ALL : CLAMCONF.EXE
        $ren CLAMCONF.EXE [-.BIN]

CLAMCONF.EXE : $(OBJ)
        LINK/EXE=CLAMCONF $(OBJ),[-.SHARED]LIBSHARED/LIB,[-.LIBCLAMAV]LIBCLAMAV/LIB , [-]OPT/OPT

CLAMCONF.OBJ : CLAMCONF.c

$!
$!
$!Descrip FRESHCLAM
$!
$COPY SYS$INPUT [.FRESHCLAM]DESCRIP.MMS

.FIRST
        $DEF SHARED [-.SHARED]
        $DEF LIBCLAMAV [-.LIBCLAMAV]


CC=cc

CFLAGS =  /INCLUDE=([],[-],ZLIB,[-.include],[-.LIBCLAMAV],[-.SHARED],[-.CLAMD])\
/DEFINE=(HAVE_CONFIG_H) /DEB \
/OPTIMIZE=(INLINE=SPEED) /FLOAT=ieee/ieee=denorm/name=(as_is,short)\
/OBJ=$> /WARN=DIS=OUTTOOFEW


OBJ = \
DNS.OBJ,\
EXECUTE.OBJ,\
FRESHCLAM.OBJ,\
MANAGER.OBJ,\
MIRMAN.OBJ,\
NONBLOCK.OBJ,\
NOTIFY.OBJ

ALL : FRESHCLAM.EXE
        $ren []FRESHCLAM.EXE [-.BIN]

FRESHCLAM.EXE : $(OBJ)
        LINK/EXE=FRESHCLAM $(OBJ),[-.SHARED]LIBSHARED/LIB,[-.LIBCLAMAV]LIBCLAMAV/LIB , [-]OPT/OPT

DNS.OBJ : DNS.c
EXECUTE.OBJ : EXECUTE.c
FRESHCLAM.OBJ : FRESHCLAM.c
MANAGER.OBJ : MANAGER.c
MIRMAN.OBJ : MIRMAN.c
NONBLOCK.OBJ : NONBLOCK.c
NOTIFY.OBJ : NOTIFY.c
$!
$WRITE SYS$OUTPUT "DESCRIP.MMS's have been created"
$WRITE SYS$OUTPUT " "
$WRITE SYS$OUTPUT " "
$WRITE SYS$OUTPUT "Now you can type @BUILD "
$!
$EXIT:
$DEFINE SYS$ERROR _NLA0:
$DEFINE SYS$OUTPUT _NLA0:
$DEL TEST.C;*
$DEL TEST.OBJ;*
$DEL TEST.EXE;*
$DEL TEST.OPT;*
$DEAS SYS$ERROR
$DEAS SYS$OUTPUT

